=== debian/changelog ===
range-v3 (0.3.5-1) unstable; urgency=medium

  * New upstream release, remove all unneeded patches.
  * Bump standards version, no changes for this.
  * Migrate Git repository to salsa.debian.org.
  * Add `Multi-Arch: foreign` line for the librange-v3-doc package.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 23 Feb 2018 22:40:10 +0300
