=== debian/changelog ===
range-v3 (0.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Bump debhelper version to 11 and standards version to 4.1.5.
    - Add the Rules-Requires-Root field into debian/control.
    - Move the HTML documentation to the main package.
  * Move cmake build dependency to Build-Depends-Arch list.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 07 Jul 2018 13:26:34 +0300
