=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
-Build-Depends: cmake (>=3.6), debhelper (>=10)
-Build-Depends-Indep: doxygen-latex <!nodoc>
-Standards-Version: 4.1.3
+Build-Depends: debhelper (>=11)
+Build-Depends-Indep: cmake (>=3.6), doxygen-latex <!nodoc>
+Standards-Version: 4.1.5
+Rules-Requires-Root: no
 Homepage: https://github.com/ericniebler/range-v3
 Vcs-Git: https://salsa.debian.org/debian/range-v3.git
 Vcs-Browser: https://salsa.debian.org/debian/range-v3
